<template>
  <section class="main-content">

    <breadcrumb separator="›">
      <breadcrumb-item label="Início" to="/admin"></breadcrumb-item>
    </breadcrumb>

    <nav class="nav" style="margin-bottom: 50px">
      <div class="nav-left">
        <div class="nav-item">
          <h2 class="title">{{pageTitle}}</h2>
        </div>
      </div>
    </nav>

    <div class="columns">
      <div class="column is-6 is-offset-3">
        <div class="control">
          <h3>Título da Iniciativa</h3>
          <span>{{getCurrentIniciativa.title}}</span>
        </div>
        
        <div class="control">
          <h3>Perguntas sobre a iniciativa:</h3>
        
          <QuestionAnswer
            :solutionId="$route.params.id"
            :questions="q"
            @input="changeDisableBtn"
          />
        </div>

        <div class="control">
          <div class="has-text-right">
            <button class="button is-primary" @click="save()" :disabled="disableFinalBtn">{{btnLabel}}</button>
          </div>
        </div>
      </div>
    </div>

  </section>
</template>

<script>
  import QuestionAnswer from './question-answer-component.vue'
  import { getQuestionsAvailable } from '../api/questions.service'
  import { mapGetters, mapActions } from 'vuex'
  
  import { getInitiative } from '../api/initiative.service.js'

  export default {
    name: 'AdicionarIniciativaPerguntas',

    components: { QuestionAnswer },

    data () {
      return {
        fData: {
          tags: []
        },
        q: [],
        answeredQuestionsCount: 0,
        disableFinalBtn: true,
        pageTitle: 'Adicione perguntas sobre a Iniciativa',
        btnLabel: 'Avançar'
      }
    },

    methods: {
      ...mapActions(['saveCurrentIniciativa']),
      changeDisableBtn(data) {
        this.answeredQuestionsCount = data.count;
        if (data.count > 0) {
          this.disableFinalBtn = false;
        } else {
          this.disableFinalBtn = true;
        }
      },
      save() {
        if (this.$route.params.action === 'editar') {
          this.$router.push(`/admin/iniciativas`);
          } else {
            this.$router.push(`/admin/iniciativa/${this.getCurrentIniciativa.id}/capa`);
         }
      }
    },

    created() {
      getQuestionsAvailable(this.$route.params.id)
        .then(
          success => {
            this.q = success.questions
          }
        )
      if (this.$route.params.action === 'editar') {
        this.pageTitle = 'Editar perguntas sobre a Iniciativa'
        this.btnLabel = "Voltar para a listagem"
      }
      if (!this.getCurrentIniciativa.title) {
        getInitiative(this.$route.params.id)
          .then(
            success => {
              this.saveCurrentIniciativa({ data: success.data, onlyStore: true });
              this.showinfo = true;
            },
            error => {
  
            }
          )
      }
    },

    computed: {
      ...mapGetters(['getCurrentIniciativa'])
    }
  }
</script>
